#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>

double timeval2us(struct timeval *tvp)
{
  return (tvp->tv_sec*(double)1000000)+tvp->tv_usec;
}

long *latency(int n, int m, int cl, int cs)
{
  long ** array;
  long * tmp;
  int i, j, k, seed=0, next, mod, chain=0;
  struct rusage usage1, usage2;

  array=(long**)malloc(n*sizeof(long*)+getpagesize());
  array=(long**)((((long)array)+getpagesize()) & ~(getpagesize()-1));
  if(n < (cs*cl)) cs=n/cl;
  mod = cs-1;
  /* printf("Latency setup cells=%x lines=%x cells/line=%x\n", n, cs, cl); */
  for(i=0; i<n; i+=cs*cl) {
    for(j=0; j<cs*cl; j+=cl) {
      next=seed*0x10450405+1;
      /* printf("%05x <- %05x\n", i + (next & mod)*cl, i + j); */
      for(k=0; k<cl; k++) {
        array[i+j+k]=(long*)(array+i+(next & mod)*cl+k);
      }
      if((next & mod)==0)
        chain=(seed & mod);
      seed=next;
    }
    for(k=0; k<cl; k++) {
      array[i+chain*cl+k]+=cs*cl;
    }
  }
  for(k=0; k<cl; k++) {
    array[i-cs*cl+chain*cl+k]-=i-1;
  }
  array[i-cs*cl+chain*cl+k-1]-=cl;

  tmp = (long *)(array);
  getrusage(RUSAGE_SELF, &usage1);
  for(j=0; j<m; j++) {
    tmp = (long *) *tmp;
  }
  getrusage(RUSAGE_SELF, &usage2);
  printf("%6.1f\n", (timeval2us(&usage2.ru_utime)-timeval2us(&usage1.ru_utime))*1000/m);
  return tmp;
}

int main(int argc, char** argv)
{
  if(argc != 3) {
    printf("Usage: bench n m  for n bytes working set and m executed loads\nOutput: number of ns load-to-load latency\nUse 100 times the number of ns in a clock tick as m for 0.01ns accuracy\n  e.g. 1000000000 for a 100Hz clock (Linux/Intel 2.4)\n");
    return 1;
  }
  /* the cl parameter is set up for 128 byte cache lines (worst case
     at the time of this writing; not sure that the cs parameter is
     about and what is right for it (see Postings for more
     explanations, but I did not get much wiser) */
  return latency(atoi(argv[1])/sizeof(long *), atoi(argv[2]), 128/sizeof(long *), 4096)==NULL;
}
